//
// file merger dialog
//
// Written by Maxwell Sayles.  Copyright (C) 2000.
//

#ifndef FILE_MERGER__DIALOG__INCLUDED
#define FILE_MERGER__DIALOG__INCLUDED

#include <windows.h>

// prototypes
class Merge_Dialog;
class FileMerger;


//
// main interface of the program, dispatches UI
//
class FileMerger_Dialog
{
// public interface
public:

// dispatching routine
	static BOOL CALLBACK DialogProc (HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

// creation/destruction
	FileMerger_Dialog (char* destinationFileName, bool deleteAfterProcessed);
	virtual ~FileMerger_Dialog ();

// interface

	char*						destinationFileName;
	bool						deleteAfterProcessed; // if true then each file is deleted after merged

// protected
protected:


	void initDialog ();

	void close ();
	void merge ();
	void doMerge ();
	void moveUp ();
	void moveDown ();
	void addFiles ();
	void removeFiles ();
	void selectDestinationFile ();
	void enterIdle ();

	void onTimer ();


// secret
private:
	HWND						hWnd;
	HBITMAP					hBmpOpenFile;

	HICON						hIconTitle [6];
	int							titleIconIndex;

	Merge_Dialog*		mergeDialog;
	FileMerger*			merger;
	int							currentFileIndex;
}; // class FileMerger_Dialog



#endif // FILE_MERGER__DIALOG__INCLUDED